#pragma once

function ersetzeZeichenkette(text as string, alt as string, neu as string) as string
  dim z as uinteger, ret as string = text
  do
    z = instr(ret, alt)
    if z = 0 then exit do
    ret = left(ret, z-1) & neu & mid(ret, z+len(alt))
  loop
  return ret
end function

function ersetzeUmlaute(text as string, fenster as integer = 0) as string
  dim as string ret = text
  if fenster = 0 then
    ret = ersetzeZeichenkette(ret, chr(195, 164), chr(132))
    ret = ersetzeZeichenkette(ret, chr(195, 182), chr(148))
    ret = ersetzeZeichenkette(ret, chr(195, 188), chr(129))
    ret = ersetzeZeichenkette(ret, chr(195, 132), chr(142))
    ret = ersetzeZeichenkette(ret, chr(195, 150), chr(153))
    ret = ersetzeZeichenkette(ret, chr(195, 156), chr(154))
    ret = ersetzeZeichenkette(ret, chr(195, 159), chr(225))
  else
    ret = ersetzeZeichenkette(ret, chr(195, 164), chr(228))
    ret = ersetzeZeichenkette(ret, chr(195, 182), chr(246))
    ret = ersetzeZeichenkette(ret, chr(195, 188), chr(252))
    ret = ersetzeZeichenkette(ret, chr(195, 132), chr(196))
    ret = ersetzeZeichenkette(ret, chr(195, 150), chr(214))
    ret = ersetzeZeichenkette(ret, chr(195, 156), chr(220))
    ret = ersetzeZeichenkette(ret, chr(195, 159), chr(223))
    ret = ersetzeZeichenkette(ret, chr(132), chr(228))
    ret = ersetzeZeichenkette(ret, chr(148), chr(246))
    ret = ersetzeZeichenkette(ret, chr(129), chr(252))
    ret = ersetzeZeichenkette(ret, chr(142), chr(196))
    ret = ersetzeZeichenkette(ret, chr(153), chr(214))
    ret = ersetzeZeichenkette(ret, chr(154), chr(220))
    ret = ersetzeZeichenkette(ret, chr(225), chr(223))
  end if
  return ret
end function

function nachricht(meldung as string, buttons as string = " OK ") as integer
  ' gibt eine Meldung mit bis zu 5 Zeilen mit bis zu 3 Antwortmoeglichkeiten aus
  ' ACHTUNG: wurde nicht unter Extrembedingungen (uebergrosse Texte) getestet!
  dim as integer textzahl, such, textlaenge, buttonlaenge, breite, hoehe, startx, starty
  dim as integer mx, my, mb, mx2, my2, fensterW, fensterH
  dim txt(1 to 5) as string, buttontxt(1 to 3) as string, buttonx(1 to 3) as integer
  screeninfo breite, hoehe
  dim as integer zhoehe = hoehe \ hiword(width)
  ' Button-Texte zusammenstellen
  buttontxt(1) =  ersetzeUmlaute(buttons)
  such = instr(buttontxt(1), "\n")
  if such = 0 then
    buttontxt(1) = left(buttontxt(1), breite\10)
    buttontxt(2) = ""
    buttontxt(3) = ""
  else
    buttontxt(2) = mid(buttontxt(1), such+2)
    buttontxt(1) = left(buttontxt(1), iif(such <= breite\30, such-1, breite\30))
    such = instr(buttontxt(2), "\n")
    if such = 0 then
      buttontxt(3) = ""
    else
      buttontxt(3) = mid(buttontxt(2), such+2)
      buttontxt(2) = left(buttontxt(2), iif(such <= breite\30, such-1, breite\30))
    end if
  end if
  for i as integer = 1 to 3
    buttontxt(i) = ersetzeUmlaute(buttontxt(i))
  next
  txt(1) = ersetzeUmlaute(meldung)
  ' Text auseinandernehmen
  for textzahl = 1 to 4
    such = instr(txt(textzahl), "\n")
    if such > 0 then
      txt(textzahl+1) = mid(txt(textzahl), such+2)
      txt(textzahl) = left(txt(textzahl), such-1)
      if textlaenge < such-1 then textlaenge = such-1
    else
      exit for
    end if
  next
  if textlaenge < len(txt(textzahl)) then textlaenge = len(txt(textzahl))
  for i as integer = 1 to 3
    if buttonlaenge < len(buttontxt(i)) then buttonlaenge = len(buttontxt(i))
  next
  ' Fensterbreite abhaengig von der Meldungslaenge
  if textlaenge > breite\8 - 2 then textlaenge = breite\8 - 2
  startx = breite\2 - 4*textlaenge - 10
  starty = hoehe\2 - 10*textzahl - 35
  fensterW = breite-2*startx+4
  fensterH = hoehe-2*starty+14
  ' Fensterbreite abhaengig von der Laenge der Buttons
  if buttontxt(3) <> "" then
    if fensterW < buttonlaenge*24 + 85 then fensterW = buttonlaenge*24 + 85
    startx = (breite-fensterW)\2 - 4
  elseif buttontxt(2) <> "" then
    if fensterW < buttonlaenge*16 + 60 then fensterW = buttonlaenge*16 + 60
    startx = (breite-fensterW)\2 - 4
  else
    if fensterW < buttonlaenge*8 + 35 then fensterW = buttonlaenge*8 + 35
    startx = (breite-fensterW)\2 - 4
  end if
  ' Test, ob die ermittelte Laenge erlaubt ist
  if fensterW >= breite then return 0
  if fensterH >= hoehe then return 0
  ' Positionen der Buttons bestimmen
  if buttontxt(3) <> "" then
    if textlaenge < 3*buttonlaenge + 9 then textlaenge = 3*buttonlaenge + 9
    buttonx(1) = fensterW\2 - buttonlaenge*12 - 32
    buttonx(2) = fensterW\2 - buttonlaenge*4 - 7
    buttonx(3) = fensterW\2 + buttonlaenge*4 + 18
  elseif buttontxt(2) <> "" then
    if textlaenge < 2*buttonlaenge + 6 then textlaenge = 2*buttonlaenge + 6
    buttonx(1) = fensterW\2 - buttonlaenge*8 - 18
    buttonx(2) = fensterW\2 + 4
    buttonx(3) = -1
  else
    if textlaenge < buttonlaenge + 3 then textlaenge = buttonlaenge + 3
    buttonx(1) = fensterW\2 - buttonlaenge*4 - 7
    buttonx(2) = -1
    buttonx(3) = -1
  end if
  ' Fenster zeichnen
  dim as any ptr speicher  = imagecreate(fensterW, fensterH)
  dim as any ptr speicher2 = imagecreate(fensterW, fensterH)
  get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher
  line (startx-2, starty-2)-step(fensterW-1, fensterH-1), MBC, bf
  line (startx, starty)-step(fensterW-5, fensterH-5),, b
  line (startx+2, starty+2)-step(fensterW-9, fensterH-9),, b
  line (startx+3, starty+3)-step(fensterW-11, fensterH-11),, b
  for i as integer = 1 to textzahl
    draw string (startx + 12, starty + i*20 - 8 + (16-zhoehe)\2), left(txt(i), textlaenge)
  next
  for i as integer = 1 to 3
    if buttonx(i) > -1 then
      line (startx + buttonx(i), starty + fensterH - 46)-step(buttonlaenge*8+10, 23),, b
      line (startx + buttonx(i)+1, starty + fensterH - 45)-step(buttonlaenge*8+8, 21),, b
      draw string (startx+buttonx(i)+(buttonlaenge-len(buttontxt(i)))*4+6, _
           starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(i)
    end if
  next
  get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher2
  dim wahl as integer, taste as string
  ' Interaktion
  do
    do
      wahl = -1
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb < 1
      ' Auf Mausdruck warten
      do
        getmouse mx, my,, mb
        taste = inkey
        sleep 1
      loop until mb = 1 or taste = chr(13) or taste = chr(27)
      if taste = chr(13) then wahl = 1 : exit do, do
      if taste = chr(27) then
        for i as integer = 3 to 1 step -1
          if buttontxt(i) <> "" then wahl = i : exit do, do
        next
      end if
      ' Button oder Fenster angeklickt?
      for i as integer = 1 to 3
        if buttonx(i) >= 0 andalso _
            mx > startx + buttonx(i) and my > starty + fensterH - 46 _
                 and mx < startx + buttonx(i) + buttonlaenge*8+10 and my < starty + fensterH - 23 then
          wahl = i
          line (startx + buttonx(i)+1, starty + fensterH - 45)-step(buttonlaenge*8+8, 21),, bf
          draw string (startx + buttonx(i)+(buttonlaenge-len(buttontxt(i)))*4+6, _
               starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(i), MBC
        end if
      next
      if wahl < 0 and (mx < startx or my < starty or mx > startx + fensterW or my > starty + fensterH) then wahl = 0
      ' auf Loslassen der Maus warten
      do
        getmouse mx2, my2,, mb
        if wahl = -1 then
          ' Fenster verschieben
          if mb < 0 then mb = 0 :  exit do
          if (mx2 <> mx or my2 <> my) then
            screenlock
            put (startx-2, starty-2), speicher, pset
            startx += mx2 - mx
            starty += my2 - my
            if startx < 2 then startx = 2
            if starty < 2 then starty = 2
            if startx >= breite - fensterW + 1 then startx = breite - fensterW + 1
            if starty >= hoehe - fensterH + 1 then starty = hoehe - fensterH + 1
            get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher
            put (startx-2, starty-2), speicher2, pset
            screenunlock
            mx = mx2
            my = my2
          end if
        end if
        sleep 1
      loop until mb = 0
    loop until wahl >= 0
    if wahl = 0 then continue do
    line (startx + buttonx(wahl)+2, starty + fensterH - 44)-step(buttonlaenge*8+6, 19), MBC, bf
    draw string (startx + buttonx(wahl)+(buttonlaenge-len(buttontxt(wahl)))*4+6, _
                starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(wahl)
    if mx2 > startx + buttonx(wahl) and my2 > starty + fensterH - 46 _
            and mx2 < startx + buttonx(wahl) + buttonlaenge*8+10 and my2 < starty + fensterH - 23 then exit do
  loop
  put (startx-2, starty-2), speicher, pset
  imagedestroy speicher
  imagedestroy speicher2
  return wahl
end function

sub richtungsadd(r as integer, byref x as integer, byref y as integer, _
                 oadd as integer, uadd as integer, ladd as integer, radd as integer)
  ' addiert je nach Richtung r zu x und y Anpassungswerte
  if r and ROben  then : y += oadd : elseif r and RUnten  then : y += uadd : end if
  if r and RLinks then : x += ladd : elseif r and RRechts then : x += radd : end if
end sub

function sucheRichtung(text as string) as integer
  dim as integer ret = 0
  if instr(text, "oben") then ret or= ROben
  if instr(text, "unten") then ret or= RUnten
  if instr(text, "links") then ret or= RLinks
  if instr(text, "rechts") then ret or= RRechts
  return ret
end function

